/*
 *	Delay functions
 *	See delay.h for details
 *
 *	Make sure this code is compiled with full optimization!!!
 */

#include	"delay.h"
#include	"dig_cross.h"
#include <p18F4620.h>

//void DelayUs(unsigned char cnt)
//{
//unsigned char	_dcnt;
//	_dcnt = (cnt)/((12000)/(XTAL_FREQ))|1;
//	 while(--_dcnt != 0)
//		  continue;
//}

void DelayMs(unsigned char cnt)
{

	unsigned char	i;
	do {
		i = 4;
		do {
			DelayUs(250);
		} while(--i);
	} while(--cnt);
}



/****************************************************************************/
/*		EEPROM WRITE is costly on instructions - make a function for it		*/
/****************************************************************************/
void EEPROM_WRITE(char addr, char _value)
{

	INTCONbits.GIE = 0; // Enble Global interrupt 

	PIR2bits.EEIF = 0; 
	EEADRH = 0;			/* This really should not be fixed to zero to allow access to remainder of EEPROM */
    EEADR  = addr; 
    EEDATA = _value;      
    EECON1bits.EEPGD = 0; 
    EECON1bits.CFGS  = 0; 
    EECON1bits.WREN  = 1; 
    EECON2 = 0x55; 
    EECON2 = 0xAA; 
    EECON1bits.WR  = 1; 
    EECON1bits.WREN  = 0; 
    while (!PIR2bits.EEIF); 
    PIR2bits.EEIF = 0 ; 

	INTCONbits.GIE = 1; // Enble Global interrupt 

	DelayMs(EEPROM_WR_Delay);

}